#########################################################################################
# Equation à résoudre : y" + y' + sin(y) = 0 (pendule libre avec frott visqueux)
# Formulation de Cauchy / Méthode d'Euler
#########################################################################################

from pylab import *

# y" + y' + sin(y) = 0 (pendule libre avec frott visqueux)
# y" = - sin(y) - y'
# On remplace cette équation d'ordre 2 par un système de deux équations d'ordre 1 :
# dy1/dt = y2
# dy2/dt = -sin(y1) - y2

# Paramètres de calcul
t0 = 0    # instant initial (secondes)
tf = 10   # instant final (secondes)
n = 10000  # nombre de points de calcul
p = (tf-t0)/n   # pas de calcul (secondes)

# conditions initiales
C0 = 1    # valeur initiale de y (y1)
C1 = 0    # valeur initiale de y'(y2)

# Résolution
T=[t0]
Y1=[C0]
Y2=[C1]
for i in range(n):
    T.append(T[i]+p)
    Y1.append(Y1[i]+p*Y2[i])
    Y2.append(Y2[i]+p*(-sin(Y1[i])-Y2[i]))

# Tracé de y(t)
plot(T,Y1)
grid()
show()

